//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "generate.h"
#include "math.h"
#include <stdlib.h>
#include <math.hpp>

//---------------------------------------------------------------------------
//  
void CreateTexture(Graphics::TBitmap *pBmp, bool Smooth, float r1, float r2, float r3, float Contrast)
{

  int X = pBmp->Width;
  int Y = pBmp->Height;

  //     X*Y
  float **s = new float*[Y];
  for( int i=0; i<Y; i++ )
    s[i] = new float[X];

  float a,b,c;
  for(int i=0; i<Y; i++)
    for(int j=0; j<X; j++)
    {
      //    
      //     
      //  ,   

      a = i+1-(Y+1)/2.0;
      b = j+1-(X+1)/2.0;
      c = 1000000.0*(j+1)*(i+1)*(X-j)*(Y-i)/(Y+1)/(Y+1)/(X+1)/(X+1);

      s[i][j] = sin(r1*c*sin(r2*(a*a+b*b)));
    }


  float sMin = s[0][0], sMax = s[0][0];
  float _s;
  for(int i=0;i<Y;i++)
    for(int j=0;j<X;j++)
    {
      if(Smooth)  //   3x3
      {
        _s = 0;
        for(int k=-1; k<=1; k++)
          for(int l=-1; l<=1; l++)
            _s += s[(i+k+Y)%Y][(j+l+X)%X];
        s[i][j] = _s / 9;
      }
      if( s[i][j] < sMin ) sMin = s[i][j];
      if( s[i][j] > sMax ) sMax = s[i][j];
    }

  //    bitmap
  Byte *ptr;
  for(int i=0; i<Y; i++)
  {
    ptr = (Byte *)pBmp->ScanLine[i]; //    
    for(int j=0; j<X; j++)
    {
      s[i][j] = 1.0-Contrast*(s[i][j]-sMin)/(sMax-sMin); //   1
      ptr[j]  = 255*s[i][j];  //      (0-255)
    }
  }

  //  
  for( int i=0; i<Y; i++ )
    delete[] s[i];
  delete[] s;

}

