#include "palette.h"

// :   ,   RGB?
// :    gif. 

//---------------------------------------------------------------------------
//     Col (   Col)
HPALETTE ColorPalette(int Col)
{
  LPLOGPALETTE lpPal;
  HPALETTE     hPal = NULL;
  HANDLE       hLogPal;
  int          wNumColors = 256;

  //    
  hLogPal = GlobalAlloc(GHND, sizeof(LOGPALETTE)
            + sizeof(PALETTEENTRY) *  wNumColors);

  //    
  lpPal = (LPLOGPALETTE)GlobalLock(hLogPal);

  //  
  lpPal->palVersion = 0x300;
  lpPal->palNumEntries = wNumColors;

  //  
  for (int i = 0; i < wNumColors; i++)
  {
    lpPal->palPalEntry[i].peRed   = i*(Col & 0x0000FF)>>8;
    lpPal->palPalEntry[i].peGreen = i*(Col & 0x00FF00)>>16;
    lpPal->palPalEntry[i].peBlue  = i*(Col & 0xFF0000)>>24;
    lpPal->palPalEntry[i].peFlags = 0;
  }

  //  
  hPal = CreatePalette(lpPal);

  GlobalUnlock(hLogPal);
  GlobalFree(hLogPal);

  //    
  return hPal;
}

//---------------------------------------------------------------------------

